;;;KOMPATIBILNOST KLOTOIDA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:clocomp ()

  (command ".undo" "be")
  (setq oos (getvar "osmode"))
  (setvar "osmode" 0)
  ;;;  
  (setq ssclo (ssadd))
  (setq eclo (entsel "\nSelect clothoid:"))
  (if eclo
    (setq ssclo (ssadd (car eclo) ssclo))
    (progn
      (princ "\nSelect clothoids...")
      (setq ssclo (ssget (list ;(cons 8 laypat)
			(cons -4 "<OR") (cons 0 "LWPOLYLINE") (cons 0 "POLYLINE") (cons -4 "OR>"))))
      )     );end if
  (setq i 0)
  (repeat (sslength ssclo)
    (setq clo (ssname ssclo i))
    (cond
      ((= "LWPOLYLINE" (cdr (assoc 0 (entget clo))))
       (setq element (entget clo))
       (setq clolinije nil cloiter 0)
       (repeat (length element)
	 (if (= 10 (car (nth cloiter element)))
	   (setq clolinije (cons (cdr (nth cloiter element)) clolinije)))
	 (setq cloiter (1+ cloiter))
	 );end repeat
       (setq clolinije (reverse clolinije)
	     ppk (car clolinije)
	     kpk (last clolinije))
       (setq a0 (cadr (nth 1 (car (cdr (assoc -3 (entget (cdr (assoc -1 element)) '("DUCKPLAN")))))))
	     a (abs a0)
	     r0 (caddr (nth 1 (car (cdr (assoc -3 (entget (cdr (assoc -1 element)) '("DUCKPLAN")))))))
	     r (cadddr (nth 1 (car (cdr (assoc -3 (entget (cdr (assoc -1 element)) '("DUCKPLAN")))))))
	     tx (cadr (nth 2 (car (cdr (assoc -3 (entget (cdr (assoc -1 element)) '("DUCKPLAN")))))))
	     ty (caddr (nth 2 (car (cdr (assoc -3 (entget (cdr (assoc -1 element)) '("DUCKPLAN")))))))
	     l (/ (* a a) r)
	     tau (/ l (* 2 r))
	     teme (polar (polar ppk 0 tx) (* 0.5 pi) ty)	     
	     )
       
       (if (< a0 0)
	   (setq znak 1)
	   (setq znak -1)
	   );end if
	 
       (setq tau (/ l (* 2 r))
	     c (polar kpk (+ (* znak tau) (* znak (* 0.5 pi)) (atan ty tx)) r)
	     )
       (if (/= r0 0)
	 (setq x (* a (sqrt (* 2 tau)) (- 1 (/ (expt tau 2) (* 5 (fakt 2)))
					  (/ (* -1 (expt tau 4)) (* 9 (fakt 4)))
					  (/ (expt tau 6) (* 13 (fakt 6)))
					  (/ (* -1 (expt tau 8)) (* 17 (fakt 8)))
					  (/ (expt tau 10) (* 21 (fakt 10)))) )
	       y (* a (sqrt (* 2 tau)) (- (/ tau 3.) (/ (expt tau 3) (* 7 (fakt 3)))
					  (/ (* -1 (expt tau 5)) (* 11 (fakt 5)))
					  (/ (expt tau 7) (* 15 (fakt 7)))
					  (/ (* -1 (expt tau 9)) (* 19 (fakt 9)))
					  (/ (expt tau 11) (* 23 (fakt 11)))) )
	       
	       xm (- x (* r (sin tau)))
	       ym (+ y (* r (cos tau)))
	       ppk (polar (polar c (angle (list tx ty) (list 0 0)) xm) (+ (* znak 0.5 pi) (angle (list tx ty) (list 0 0))) ym)
	       teme (polar (polar ppk 0 tx) (* 0.5 pi) ty))	       
             );end if
       
       (entdel (cdr (assoc -1 element)))
       
       ;GCM klotoida
       (princ "\nDRRD->GCM...")
       (command ".3dpoly" (car clolinije))
       (setq clolinije (cdr clolinije))
       (while clolinije
	 (command (car clolinije))
	 (setq clolinije (cdr clolinije))
	 );end while
       (command "")
       
       (setq klotoida (entget (entlast)))
       
       (if  (not (tblsearch "appid" "GAVRAN")) (regapp "GAVRAN"))
       (setq xdata (list (cons -3 (list (cons "GAVRAN" (list (cons 1000 "Clothoid data")
							     (cons 1002 "{")
							     (cons 1010 (list a0 r0 r))
							     (cons 1011 ppk)
							     (cons 1013 (list (* 10 (cos (angle ppk teme)))
									      (* 10 (sin (angle ppk teme)))
									      0.0))
							     (cons 1002 "}")
							     ))))));;;
       (setq klotoida (append klotoida xdata))
       (entmod klotoida)
       );end case
      ((= "POLYLINE" (cdr (assoc 0 (entget clo))))
       (setq clo (entget clo)
	     a (car (cdr (nth 3 (car (cdr (assoc -3 (entget (cdr (assoc -1 clo)) '("GAVRAN"))))))))
	     r0 (cadr (cdr (nth 3 (car (cdr (assoc -3 (entget (cdr (assoc -1 clo)) '("GAVRAN"))))))))
	     r (caddr (cdr (nth 3 (car (cdr (assoc -3 (entget (cdr (assoc -1 clo)) '("GAVRAN"))))))))
	     ppk (cdr (nth 4 (car (cdr (assoc -3 (entget (cdr (assoc -1 clo)) '("GAVRAN")))))))
	     cosa (car (cdr (nth 5 (car (cdr (assoc -3 (entget (cdr (assoc -1 clo)) '("GAVRAN"))))))))
	     sina (cadr (cdr (nth 5 (car (cdr (assoc -3 (entget (cdr (assoc -1 clo)) '("GAVRAN"))))))))
	     )
       
       (setq clolinije nil cloiter 0)
       (setq cloel clo)
       (while (/= (cdr (assoc 0 (entget (entnext (cdr (assoc -1 cloel)))))) "SEQEND")
	 (setq clolinije (reverse (cons (cdr (assoc 10 (entget (entnext (cdr (assoc -1 cloel))))))
					(reverse clolinije))))
	 (setq cloel (entget (entnext (cdr (assoc -1 cloel)))))
	 );end while
       (setq cloel clo)
       (while (/= (cdr (assoc 0 cloel)) "SEQEND")
	 (setq oldcloel cloel)
	 (setq cloel (entget (entnext (cdr (assoc -1 cloel)))))
	 (entdel (cdr (assoc -1 oldcloel)))
	 );end while
       ;DRD klotoida
       (princ "\nGCM->DRRD...")
       (command ".pline" (car clolinije))
       (setq clolinije (cdr clolinije))
       (while clolinije
	 (command (car clolinije))
	 (setq py (car clolinije))
	 (setq clolinije (cdr clolinije))
	 );end while
       (command "")
       
       (setq klotoida (entget (entlast)))
       (if  (not (tblsearch "appid" "DUCKPLAN")) (regapp "DUCKPLAN"))
       (setq xdata (list (cons -3 (list (cons "DUCKPLAN" (list (cons 1010 (list a r0 r));A R0 R
						      (cons 1013 (list cosa sina 0.0));TEME (tangentni pravac)
						      ))))))
       (setq klotoida (append klotoida xdata))
       (entmod klotoida)
       );end case
      );end cond
    (setq i (1+ i))
    );end repeat

  ;;;
  (setvar "osmode" oos)
  (command ".undo" "e")
  (princ)
  );end defun


;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:gcm->cecs ()
  (command ".undo" "be")
  (setq oos (getvar "osmode"))
  (setvar "osmode" 0)

  ;;;
  (princ "\nSelect SECTION BLOCK's!")
  (setq ssgcm (ssget '((0 . "INSERT") (2 . "SECTION"))))
  (princ "\nAdding CECS 'cross-section markers!...")
  (terpri)
  (setq i 0)
  (repeat (sslength ssgcm)
    (setq esecblok (ssname ssgcm i)
	    secblok (entget esecblok)
	    inspt (cdr (assoc 10 secblok)) )
    (setq secnum (cdr (nth 3 (car (cdr (assoc -3 (entget esecblok '("*"))))))) )
      (setq attr (entnext esecblok)
	    sta (atof (cdr (assoc 1 (entget attr))))
	    attr (entnext attr)
	    basel (atof (cdr (assoc 1 (entget attr))))
	    attr (entnext attr)
	    lsw (atof (cdr (assoc 1 (entget attr))))
	    attr (entnext attr)
	    ymin (atof (cdr (assoc 1 (entget attr))))
	    attr (entnext attr)
	    ymax (atof (cdr (assoc 1 (entget attr))))
	    attr (entnext attr)
	    vspace (atof (cdr (assoc 1 (entget attr))))
	    attr (entnext attr)
	    vegzag (atof (cdr (assoc 1 (entget attr))))
	    attr (entnext attr)
	    rsw (atof (cdr (assoc 1 (entget attr))))
	    )
    (setq thei (cdr (caddr (caddr (assoc -3 (entget esecblok '("*"))))))
	  )
    (if (not thei)
      (command ".-insert" "secblk" (cdr (assoc 10 secblok)) (* 0.2 (cdr (assoc 41 secblok))) "" 0 ymax
	       rsw secnum (* vspace 0.1492875) vspace vegzag basel ymin lsw sta)
      (command ".-insert" "secblk" (cdr (assoc 10 secblok)) (* 0.2 (cdr (assoc 41 secblok))) "" 0 ymax
	       rsw secnum thei vspace vegzag basel ymin lsw sta)
      );end if
    
    (setq i (1+ i))
    );end repeat

;;;  (-3 ("GAVRAN" (1002 . "{") (1005 . 
;;;"7B2CF") (1040 . 12.0) (1002 . "}")) ("GCM-SEC-TXT" (1002 . "{") (1040 . 0.225) 
;;;(1002 . "}")))


  ;;;
  (setvar "osmode" oos)
  (command ".undo" "e")
  (princ)  
  );end defun


(princ "\nKomande:\nCLOCOMP - konverzija klotoida\nGCM->CECS - konverzija poprecnih profila\n")



(princ)